#include "StdAfx.h"
#include ".\LuaPlayer.h"

static libvlc_instance_t * vlc_inst;
static libvlc_media_t *media;
static libvlc_media_player_t *media_player;

int LuaPlayer::Init(lua_State* luaState)
{
    /* Load the VLC engine */
    vlc_inst = libvlc_new (0, NULL);
	return 1 ;
}

int LuaPlayer::Destroy(lua_State* luaState)
{
	libvlc_release (vlc_inst);
	return 1;
}

int LuaPlayer::Play(lua_State* luaState)
{
	/*
    Player** ppMyClass= reinterpret_cast<Player**>(luaL_checkudata(luaState,1,MY_CLASS_LUA_CLASS));   
    if(ppMyClass && (*ppMyClass))
    {
        int lhs = static_cast<int>(lua_tointeger(luaState,2));
        int rhs = static_cast<int>(lua_tointeger(luaState,3));
        int result = (*ppMyClass)->Add(lhs,rhs);
        lua_pushinteger(luaState,result);
        return 1;     
    }
    
    lua_pushnil(luaState);*/ 
	
	const char* cHwnd = luaL_checkstring(luaState, 2);
	cHwnd = cHwnd + 10;
	HWND hwnd = (HWND)strtol(cHwnd,NULL,16);

	const char* path = luaL_checkstring(luaState,3);

    /* Create a new item */
	media = libvlc_media_new_path (vlc_inst, path);
    //m = libvlc_media_new_path (inst, "D:\\video.mp4");
    /* Create a media player playing environement */
    media_player = libvlc_media_player_new_from_media (media);
    /* No need to keep the media now */
    libvlc_media_release (media);
 
 //#if 0
    /* This is a non working code that show how to hooks into a window,
     * if we have a window around */
    //libvlc_media_player_set_xdrawable (mp, xdrawable);
    /* or on windows */
	libvlc_media_player_set_hwnd (media_player, hwnd);
    /* or on mac os */
    //libvlc_media_player_set_nsobject (mp, view);
//#endif
 
    /* play the media_player */
    libvlc_media_player_play (media_player);
    
    //sleep (10); /* Let it play a bit */

    return 1;
}

int LuaPlayer::Pause(lua_State* luaState)
{
	libvlc_media_player_pause(media_player);
	return 1 ;
}

int LuaPlayer::Stop(lua_State* luaState)
{
	if(media_player)
	{
		libvlc_media_player_stop (media_player);
		libvlc_media_player_release (media_player);
	}
	return 1;
}

int LuaPlayer::SetPosition(lua_State* luaState)
{
	if(media_player)
	{
		float pos = luaL_checklong(luaState, 2);
		float p = pos/100;
		libvlc_media_player_set_position(media_player,p);
	}
	return 1;
}

int LuaPlayer::GetPosition(lua_State* luaState)
{
	if(media_player)
	{
		float p = libvlc_media_player_get_position(media_player);
		lua_pushnumber(luaState, p);
	}
	return 1;
}

int LuaPlayer::GetLength(lua_State* luaState)
{
	return 1;
}

int LuaPlayer::AttachResultListener(lua_State* luaState)
{
	/*
    MyClass** ppMyClass= reinterpret_cast<MyClass**>(luaL_checkudata(luaState,1,MY_CLASS_LUA_CLASS));   
    if(ppMyClass && (*ppMyClass))
    {
        if(!lua_isfunction(luaState,2))
        {
            return 0;
        }
        //¼Detach,ȷͷlua function
        long functionRef = luaL_ref(luaState,LUA_REGISTRYINDEX);
        (*ppMyClass)->AttachResultListener(reinterpret_cast<DWORD>(luaState),functionRef,LuaMyClass::LuaListener);
    }
	*/
    return 0;
}

int LuaPlayer::DeleteSelf(lua_State* luaState)
{
	/*
     MyClass** ppMyClass= reinterpret_cast<MyClass**>(luaL_checkudata(luaState,1,MY_CLASS_LUA_CLASS));   
     if(ppMyClass)
     {
         delete (*ppMyClass);
     }
	 */
    return 0;
}

void LuaPlayer::LuaListener(DWORD dwUserData1,DWORD dwUserData2,int nResult)
{
    lua_State* luaState = reinterpret_cast<lua_State*>(dwUserData1);
    int nNowTop = lua_gettop(luaState);
    lua_rawgeti(luaState,LUA_REGISTRYINDEX,dwUserData2 );

    lua_pushinteger(luaState,nResult);
    //BoltҪʹXLLRT_LuaCalllua_pcall
	//ԻøȶԺ͸״̬Ϣ
    int nLuaResult = XLLRT_LuaCall(luaState,1,0,L"LuaPlayer::LuaListener");
    
	//֮luaState֮ǰ״̬
	//õluaзֵ
	//ڴǰעXLLRT_LuaCallķֵnLuaResultȷϽűȷִ
    lua_settop(luaState,nNowTop);
    return ;   
}

static XLLRTGlobalAPI LuaPlayerMemberFunctions[] = 
{
    {"Init",LuaPlayer::Init},
	{"Destroy",LuaPlayer::Destroy},
    {"Play",LuaPlayer::Play},
    {"Pause",LuaPlayer::Pause},
    {"Stop",LuaPlayer::Stop},
	{"GetPosition",LuaPlayer::GetPosition},
    {"SetPosition",LuaPlayer::SetPosition},
	{"GetLength",LuaPlayer::GetLength},
    {"AttachResultListener",LuaPlayer::AttachResultListener},
    {"__gc",LuaPlayer::DeleteSelf},
    {NULL,NULL}
};

void LuaPlayer::RegisterClass(XL_LRT_ENV_HANDLE hEnv)
{
    if(hEnv == NULL)
    {
        return;
    }

    long nLuaResult = XLLRT_RegisterClass(hEnv,PLAYER_LUA_CLASS,LuaPlayerMemberFunctions,NULL,0);
}
//------------------------------------------------------------------
Player* LuaPlayerFactory::CreateInstance()
{
    return new Player();
}

int LuaPlayerFactory::CreateInstance(lua_State* luaState)
{
    Player* pResult = new Player();
    XLLRT_PushXLObject(luaState,PLAYER_LUA_CLASS,pResult);
    return 1;
}

LuaPlayerFactory* __stdcall LuaPlayerFactory::Instance(void*)
{
    static LuaPlayerFactory* s_pTheOne = NULL;
    if(s_pTheOne == NULL)
    {
        s_pTheOne = new LuaPlayerFactory();
    }
    return s_pTheOne;
}

static XLLRTGlobalAPI LuaPlayerFactoryMemberFunctions[] = 
{
    {"CreateInstance",LuaPlayerFactory::CreateInstance},
    {NULL,NULL}
};

void LuaPlayerFactory::RegisterObj(XL_LRT_ENV_HANDLE hEnv)
{
    if(hEnv == NULL)
	{
        return ;
	}

    XLLRTObject theObject;
    theObject.ClassName = PLAYER_FACTORY_LUA_CLASS;
    theObject.MemberFunctions = LuaPlayerFactoryMemberFunctions;
    theObject.ObjName = PLAYER_FACTORY_LUA_OBJ;
    theObject.userData = NULL;
    theObject.pfnGetObject = (fnGetObject)LuaPlayerFactory::Instance;

    XLLRT_RegisterGlobalObj(hEnv,theObject); 
}