#pragma once
#include "WebEventSink.h" 

#define XLUE_OSSHELL_CLASSNAME "IEIntercepter.OSShell.Class"
#define XLUE_OSSHELL_OBJNAME   "IEIntercepter.OSShell"


void Unicode_to_UTF8(const wchar_t* in, unsigned int len, std::string& out);

void UTF8_to_Unicode(const char* in, unsigned int len, std::wstring& out);

void Unicode_to_ANSI(const wchar_t* in, unsigned int len, std::string& out);

void ANSI_to_Unicode(const char* in, unsigned int len, std::wstring& out);




class LuaShell : public CWebEventSink      
{
public:
	LuaShell(void);
	~LuaShell(void);
	static LuaShell* _lua_shell;  
	static LuaShell* GetInstance()  ;  
	
	lua_State* _l ;  
	void SetGetText(WCHAR* text)  ;  
	void SetPostText(WCHAR* text) ;     

	bool is_monitor  ;
	bool is_ReBeforeNavaigated2;    
	
	typedef void (WINAPI *PSWITCHTOTHISWINDOW) (HWND,BOOL); 

	void LuaShell::PCStrToPPostData(LPCTSTR lstrPostData,VARIANT* pvNewPostData) ;  
	
	static CComPtr<IWebBrowser2> pWebBrowser2;  
	static CComPtr<IWebBrowser2> lastpWebBrowser2;  
	CComPtr<IWebBrowser2> GetIWebBrowser2() ; 
	void RegisterSelfAsIeEventDealer(IWebBrowser2 *ppWebBrowser2);
	DWORD m_dwCookie ; 
	STDMETHODIMP OnBeforeNavigate2(
		IDispatch *pDisp, VARIANT *pvUrl, VARIANT *pvFlags, VARIANT *pvTargetFrameName,
		VARIANT *pvPostData, VARIANT *pvHeaders, VARIANT_BOOL *pvCancel)  ; 

	static void* __stdcall GetObject(void*ud); 
	static long RegisterObject(XL_LRT_ENV_HANDLE hEnv);

	
	DWORD static set_get_text_data_1 ; 
	DWORD static set_get_text_data_2 ;  
	DWORD static set_post_text_data_1 ; 
	DWORD static set_post_text_data_2 ; 
	
	int static AttachSetGetTextListener(lua_State* luaState) ;  
	int static AttachSetPostTextListener(lua_State* luaState) ;  

	int static StartMonitor(lua_State* luaState) ; 
	int static EndMonitor(lua_State* luaState) ; 
	int static Send(lua_State* luaState) ;       
	int static LuaMessageBox(lua_State* luaState);
};
